package com.nisum.kafka.kafka_training;

import java.time.Duration;
import java.util.Arrays;
import java.util.Collections;
import java.util.Properties;

import org.apache.kafka.clients.consumer.ConsumerConfig;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.apache.kafka.common.TopicPartition;
import org.apache.kafka.common.serialization.StringDeserializer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ConsumerDemoAssignSeek {

	public static void main(String[] args) {
		Logger logger = LoggerFactory.getLogger(ConsumerDemoAssignSeek.class.getName());

		// TODO Auto-generated method stub
		
	        //System.out.println("Hello World");
	        //create consumer configs
	        Properties prop = new Properties();
	        prop.setProperty(ConsumerConfig.BOOTSTRAP_SERVERS_CONFIG,"localhost:9092");
	        prop.setProperty(ConsumerConfig.KEY_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class.getName());
	        prop.setProperty(ConsumerConfig.VALUE_DESERIALIZER_CLASS_CONFIG,StringDeserializer.class.getName());
	      // prop.setProperty(ConsumerConfig.GROUP_ID_CONFIG,"My_first_application");
	        prop.setProperty(ConsumerConfig.AUTO_OFFSET_RESET_CONFIG,"earliest");

	        //create consumer and subscribe our  consumer to topic

	        KafkaConsumer<String,String> consumer = new KafkaConsumer<String, String>(prop);
	                 //consumer.subscribe(Collections.singleton("second_topic"));
	                 
	                 //Assign and seek are mostly used replay data or fetch a specific message
	                 TopicPartition partitionToReadFrom  = new TopicPartition("second_topic",0);
	                 consumer.assign(Arrays.asList(partitionToReadFrom));
	                 //consumer.subscribe(Arrays.asList("first_topic","second_topic"));
	                 //seek
	                 long offsetToReadFrom =15l;
	                 consumer.seek(partitionToReadFrom, offsetToReadFrom);
	                 int numberofMessagesToRead = 5;
	                 boolean keepOnReading=true;
	                 int numberOfMessagesReadsoFar = 0;
	        //poll for new data
	        while(keepOnReading){
	          ConsumerRecords<String,String> reoords= consumer.poll(Duration.ofMillis(100));
	          for(ConsumerRecord record:reoords){
	        	  numberOfMessagesReadsoFar+=1;
	              logger.info("Key: " + record.key()+"value" +record.value());
	              logger.info("Partition:" + record.partition()+"offset"+record.offset());
if(numberOfMessagesReadsoFar>= numberofMessagesToRead) {
	keepOnReading=false;
	break;
}
	          }
	        }




	    }

	

}
