package com.nisum.kafka.kafka_training;

import java.util.Properties;

import org.apache.kafka.clients.producer.Callback;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.clients.producer.RecordMetadata;
import org.apache.kafka.common.serialization.StringSerializer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class ProducerDemoWithKeys {
	

	public static void main(String[] args) {


	       // final Logger logger = LoggerFactory.getLogger(ProducerDemoWithCallback.class);
	        //System.out.println("Hello World");
	        //String bootStrapProp
		final Logger logger = LoggerFactory.getLogger(ProducerDemoWithKeys.class);
	        Properties prop = new Properties();
	        prop.setProperty(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG,"localhost:9092");
	        prop.setProperty(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, StringSerializer.class.getName());
	        prop.setProperty(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG,StringSerializer.class.getName());

	        KafkaProducer<String,String> producer = new KafkaProducer<String, String>(prop);

	        for(int i=0;i <10 ;i ++) {
	        	 String topic ="second_topic";
	             String value = "Hello World"+i;
	             String key = "id_" + i;
	         ProducerRecord<String, String> record = new ProducerRecord<String, String>(topic,value,key);//// The same key message will go to same partiotion always
	          //  ProducerRecord<String, String> record = new ProducerRecord<String, String>("second_topic", "Hello World"+i);
	            producer.send(record, new Callback() {
	                public void onCompletion(RecordMetadata recordMetadata, Exception e) {
	                    if (e == null) {
	                    	logger.info("Received meta data \n" + "Topic:" + recordMetadata.topic() +"\n"+
	                                "partition:" + recordMetadata.partition() + "\n" +
	                                "offsets" + recordMetadata.offset()+"\n"
	                                );
	                    } else {
	                        System.out.println("Error while producing" + e);
	                        logger.error("Error while producing" , e);
	                        
	                    }
	                }
	            });
	        }
	        producer.flush();
	        producer.close();



	    
	}

}
